#
# Copyright 2025 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-incremental-export-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_11_42.web.objects.TypedObject import TypedObject
from delphixpy.v1_11_42 import common

class __Undef:
    def __repr__(self):
        return "undef"

    def __setattr__(self, name, value):
        raise Exception('Cannot modify attributes of __Undef.')

_UNDEFINED = __Undef()

class IncrementalExportParameters(TypedObject):
    """
    *(extends* :py:class:`v1_11_42.web.vo.TypedObject` *)* The parameters for
    the Incremental Export.
    """
    def __init__(self, undef_enabled=True):
        super().__init__()
        self._type = ("IncrementalExportParameters", True)
        self._backup_frequency_minutes = (self.__undef__, True)


    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super().from_dict(data, dirty, undef_enabled)
        obj._backup_frequency_minutes = (data.get("backupFrequencyMinutes", obj.__undef__), dirty)
        if obj._backup_frequency_minutes[0] is not None and obj._backup_frequency_minutes[0] is not obj.__undef__:
            assert isinstance(obj._backup_frequency_minutes[0], int), ("Expected one of ['integer'], but got %s of type %s" % (obj._backup_frequency_minutes[0], type(obj._backup_frequency_minutes[0])))
            common.validate_format(obj._backup_frequency_minutes[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False, belongs_to_parent=False):
        dct = super().to_dict(dirty, belongs_to_parent)

        def dictify(obj, prop_is_list_or_vo=False):
            if isinstance(obj, list):
                return [dictify(o, prop_is_list_or_vo) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict(dirty=dirty, belongs_to_parent=prop_is_list_or_vo)
            else:
                return obj
        if "backup_frequency_minutes" == "type" or (self.backup_frequency_minutes is not self.__undef__ and (not (dirty and not self._backup_frequency_minutes[1]) or self.is_dirty_list(self.backup_frequency_minutes, self._backup_frequency_minutes) or belongs_to_parent)):
            dct["backupFrequencyMinutes"] = dictify(self.backup_frequency_minutes)
        elif belongs_to_parent and self.backup_frequency_minutes is self.__undef__:
            dct["backupFrequencyMinutes"] = 30
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._backup_frequency_minutes = (self._backup_frequency_minutes[0], True)

    def is_dirty(self):
        return any([self._backup_frequency_minutes[1]])

    def is_dirty_list(self, prop_name, private_var):
        if isinstance(prop_name, list) and prop_name and hasattr(prop_name[0], 'type'):
            for item in prop_name:
                if isinstance(item, list):
                    if self.is_dirty_list(item) or item.is_dirty():
                        return True
                elif item.is_dirty():
                    return True
        else:
            return private_var[1]
        return False

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, IncrementalExportParameters):
            return False
        return super().__eq__(other) and \
               self.backup_frequency_minutes == other.backup_frequency_minutes

    def __ne__(self, other):
        return not self.__eq__(other)

    def __hash__(self):
        return id(self)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def backup_frequency_minutes(self):
        """
        *(default value: 30)* The frequency with which the incremental backup
        will be taken in minutes.

        :rtype: ``int``
        """
        return self._backup_frequency_minutes[0]

    @backup_frequency_minutes.setter
    def backup_frequency_minutes(self, value):
        self._backup_frequency_minutes = (value, True)

