#
# Copyright 2025 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-engine-info-filter.json
#
# Do not edit this file manually!
#

from delphixpy.v1_11_43.web.objects.TypedObject import TypedObject
from delphixpy.v1_11_43 import common

class __Undef:
    def __repr__(self):
        return "undef"

    def __setattr__(self, name, value):
        raise Exception('Cannot modify attributes of __Undef.')

_UNDEFINED = __Undef()

class EngineInfoFilter(TypedObject):
    """
    *(extends* :py:class:`v1_11_43.web.vo.TypedObject` *)* Engine info filter.
    """
    def __init__(self, undef_enabled=True):
        super().__init__()
        self._type = ("EngineInfoFilter", True)
        self._hostname = (self.__undef__, True)
        self._ip_addresses = (self.__undef__, True)


    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super().from_dict(data, dirty, undef_enabled)
        obj._hostname = (data.get("hostname", obj.__undef__), dirty)
        if obj._hostname[0] is not None and obj._hostname[0] is not obj.__undef__:
            assert isinstance(obj._hostname[0], str), ("Expected one of ['string'], but got %s of type %s" % (obj._hostname[0], type(obj._hostname[0])))
            common.validate_format(obj._hostname[0], "None", None, None)
        obj._ip_addresses = []
        for item in data.get("ipAddresses") or []:
            assert isinstance(item, str), ("Expected one of ['string'], but got %s of type %s" % (item, type(item)))
            common.validate_format(item, "None", None, None)
            obj._ip_addresses.append(item)
        obj._ip_addresses = (obj._ip_addresses, dirty)
        return obj

    def to_dict(self, dirty=False, belongs_to_parent=False):
        dct = super().to_dict(dirty, belongs_to_parent)

        def dictify(obj, prop_is_list_or_vo=False):
            if isinstance(obj, list):
                return [dictify(o, prop_is_list_or_vo) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict(dirty=dirty, belongs_to_parent=prop_is_list_or_vo)
            else:
                return obj
        if "hostname" == "type" or (self.hostname is not self.__undef__ and (not (dirty and not self._hostname[1]) or self.is_dirty_list(self.hostname, self._hostname) or belongs_to_parent)):
            dct["hostname"] = dictify(self.hostname)
        if "ip_addresses" == "type" or (self.ip_addresses is not self.__undef__ and (not (dirty and not self._ip_addresses[1]) or self.is_dirty_list(self.ip_addresses, self._ip_addresses) or belongs_to_parent)):
            dct["ipAddresses"] = dictify(self.ip_addresses, prop_is_list_or_vo=True)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._hostname = (self._hostname[0], True)
        self._ip_addresses = (self._ip_addresses[0], True)

    def is_dirty(self):
        return any([self._hostname[1], self._ip_addresses[1]])

    def is_dirty_list(self, prop_name, private_var):
        if isinstance(prop_name, list) and prop_name and hasattr(prop_name[0], 'type'):
            for item in prop_name:
                if isinstance(item, list):
                    if self.is_dirty_list(item) or item.is_dirty():
                        return True
                elif item.is_dirty():
                    return True
        else:
            return private_var[1]
        return False

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, EngineInfoFilter):
            return False
        return super().__eq__(other) and \
               self.hostname == other.hostname and \
               self.ip_addresses == other.ip_addresses

    def __ne__(self, other):
        return not self.__eq__(other)

    def __hash__(self):
        return id(self)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def hostname(self):
        """
        Filter based on Delphix hostname.

        :rtype: ``str``
        """
        return self._hostname[0]

    @hostname.setter
    def hostname(self, value):
        self._hostname = (value, True)

    @property
    def ip_addresses(self):
        """
        Delphix IP addresses.

        :rtype: ``list`` of ``str``
        """
        return self._ip_addresses[0]

    @ip_addresses.setter
    def ip_addresses(self, value):
        self._ip_addresses = (value, True)

