#
# Copyright 2025 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-mssql-incremental-export-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.web.objects.MSSqlExportParameters import MSSqlExportParameters
from delphixpy import common

class __Undef:
    def __repr__(self):
        return "undef"

    def __setattr__(self, name, value):
        raise Exception('Cannot modify attributes of __Undef.')

_UNDEFINED = __Undef()

class MSSqlIncrementalExportParameters(MSSqlExportParameters):
    """
    *(extends* :py:class:`delphixpy.web.vo.MSSqlExportParameters` *)* The
    parameters to use as input to incrementally export MSSQL databases.
    """
    def __init__(self, undef_enabled=True):
        super().__init__()
        self._type = ("MSSqlIncrementalExportParameters", True)
        self._recovery_model = (self.__undef__, True)
        self._recover_database = (self.__undef__, True)


    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super().from_dict(data, dirty, undef_enabled)
        obj._recovery_model = (data.get("recoveryModel", obj.__undef__), dirty)
        if obj._recovery_model[0] is not None and obj._recovery_model[0] is not obj.__undef__:
            assert isinstance(obj._recovery_model[0], str), ("Expected one of ['string'], but got %s of type %s" % (obj._recovery_model[0], type(obj._recovery_model[0])))
            common.validate_format(obj._recovery_model[0], "None", None, None)
        obj._recover_database = (data.get("recoverDatabase", obj.__undef__), dirty)
        if obj._recover_database[0] is not None and obj._recover_database[0] is not obj.__undef__:
            assert isinstance(obj._recover_database[0], bool), ("Expected one of ['boolean'], but got %s of type %s" % (obj._recover_database[0], type(obj._recover_database[0])))
            common.validate_format(obj._recover_database[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False, belongs_to_parent=False):
        dct = super().to_dict(dirty, belongs_to_parent)

        def dictify(obj, prop_is_list_or_vo=False):
            if isinstance(obj, list):
                return [dictify(o, prop_is_list_or_vo) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict(dirty=dirty, belongs_to_parent=prop_is_list_or_vo)
            else:
                return obj
        if "recovery_model" == "type" or (self.recovery_model is not self.__undef__ and (not (dirty and not self._recovery_model[1]))):
            dct["recoveryModel"] = dictify(self.recovery_model)
        if dirty and "recoveryModel" in dct:
            del dct["recoveryModel"]
        if "recover_database" == "type" or (self.recover_database is not self.__undef__ and (not (dirty and not self._recover_database[1]))):
            dct["recoverDatabase"] = dictify(self.recover_database)
        if dirty and "recoverDatabase" in dct:
            del dct["recoverDatabase"]
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._recovery_model = (self._recovery_model[0], True)
        self._recover_database = (self._recover_database[0], True)

    def is_dirty(self):
        return any([self._recovery_model[1], self._recover_database[1]])

    def is_dirty_list(self, prop_name, private_var):
        if isinstance(prop_name, list) and prop_name and hasattr(prop_name[0], 'type'):
            for item in prop_name:
                if isinstance(item, list):
                    if self.is_dirty_list(item) or item.is_dirty():
                        return True
                elif item.is_dirty():
                    return True
        else:
            return private_var[1]
        return False

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, MSSqlIncrementalExportParameters):
            return False
        return super().__eq__(other) and \
               self.recovery_model == other.recovery_model and \
               self.recover_database == other.recover_database

    def __ne__(self, other):
        return not self.__eq__(other)

    def __hash__(self):
        return hash((
            super().__hash__(),
            self.recovery_model,
            self.recover_database,
        ))

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def recovery_model(self):
        """
        Recovery model of the incremental database.

        :rtype: ``str``
        """
        return self._recovery_model[0]

    @property
    def recover_database(self):
        """
        Exported database will always be recovered with NO_RECOVERY option to
        support restoring incremental logs.

        :rtype: ``bool``
        """
        return self._recover_database[0]

